﻿using Syncfusion.UI.Xaml.Diagram;
using Syncfusion.UI.Xaml.Diagram.Controls;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace CustomContextMenu
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            diagramcontrol.Tool = Tool.ZoomPan;
            diagramcontrol.Nodes = new ObservableCollection<Node>();
            diagramcontrol.Connectors = new ObservableCollection<Connector>();
            //To remove the Diagraming object ContextMenu
            diagramcontrol.Menu = null;

            Node n = new Node()
            {
                UnitHeight = 100,
                UnitWidth = 100,
                OffsetX = 100,
                OffsetY = 100,
                Content = "node",
                Shape=new RectangleGeometry() { Rect=new Rect(0,0,10,10)},
                ShapeStyle=this.Resources["NodeStyle"] as Style  
            };            
            Connector con = new Connector()
            {
                SourcePoint = new Point(200, 200),
                TargetPoint = new Point(300, 300)

             };          
            (diagramcontrol.Connectors as ICollection<Connector>).Add(con);
            (diagramcontrol.Nodes as ObservableCollection<Node>).Add(n);
            (diagramcontrol.Info as IGraphInfo).ItemSelectedEvent += MainWindow_ItemSelectedEvent;
        }

        private void MainWindow_ItemSelectedEvent(object sender, DiagramEventArgs args)
        {
            if (args.Item is INode)
            {
                INode n = args.Item as INode;
                n.Constraints = n.Constraints & ~NodeConstraints.InheritMenu;
                //show the CustomMenuItem
                n.Constraints = n.Constraints | NodeConstraints.Menu;
                n.Menu = new DiagramMenu();
                n.Menu.MenuItems = new ObservableCollection<DiagramMenuItem>();
                DiagramMenuItem m1 = new DiagramMenuItem()
                {
                    Content = "Cut",
                    Command = (diagramcontrol.Info as IGraphInfo).Commands.Cut
                };
                DiagramMenuItem m2 = new DiagramMenuItem()
                {
                    Content = "Copy",
                    Command = (diagramcontrol.Info as IGraphInfo).Commands.Copy
                };
                DiagramMenuItem m3 = new DiagramMenuItem()
                {
                    Content = "Paste",
                    Command = (diagramcontrol.Info as IGraphInfo).Commands.Paste
                };
                (n.Menu.MenuItems as ICollection<DiagramMenuItem>).Add(m1);
                (n.Menu.MenuItems as ICollection<DiagramMenuItem>).Add(m2);
                (n.Menu.MenuItems as ICollection<DiagramMenuItem>).Add(m3);
                
            }
        }
       
    } 
}
